function readCategoriesTemplate(response, keywords){

    // html for listing categories
    read_categories_html="";

    // search categories
    read_categories_html+="<form id='search-category-form' action='#' method='post'>";
    read_categories_html+="<div class='input-group pull-left w-30-pct' ";
    read_categories_html+="data-toggle='tooltip' title='Search categories.' data-placement='right'>";

        read_categories_html+="<input type='text' value=\"" + keywords + "\" name='keywords' class='form-control category-search-keywords' placeholder='Search categories...' />";

        read_categories_html+="<span class='input-group-btn'>";
            read_categories_html+="<button type='submit' class='btn btn-default' type='button'>";
                read_categories_html+="<span class='glyphicon glyphicon-search'></span>";
            read_categories_html+="</button>";
        read_categories_html+="</span>";

    read_categories_html+="</div>";
    read_categories_html+="</form>";

    // when clicked, it will load the create categories form
    read_categories_html+="<div id='create-category' class='btn btn-primary pull-right m-b-15px create-category-button'>";
        read_categories_html+="<span class='glyphicon glyphicon-plus'></span> Create Category";
    read_categories_html+="</div>";

    // export categories to csv
    read_categories_html+="<a href='http://localhost/api/category/export_csv.php' class='btn btn-info pull-right margin-right-1em' ";
    read_categories_html+="data-toggle='tooltip' title='Download categories.' data-placement='top'>";
        read_categories_html+="<span class='glyphicon glyphicon-download-alt'></span> Export CSV";
    read_categories_html+="</a>";

    // tell the user if no products found
    if(response.message=="No categories found."){
        read_products_html+="<div class='overflow-hidden w-100-pct'>";
            read_products_html+="<div class='alert alert-danger'>No products found.</div>";
        read_products_html+="</div>";
    }

    // display products if they exist
    else{

        // start table
        read_categories_html+="<table class='table table-bordered table-hover'>";

            // creating our table heading
            read_categories_html+="<tr>";
                read_categories_html+="<th class='w-30-pct'>Name</th>";
                read_categories_html+="<th class='w-40-pct'>Description</th>";
                read_categories_html+="<th class='w-30-pct text-align-center'>Action</th>";
            read_categories_html+="</tr>";

        // loop through returned list of data
        $.each(response.records, function(key, val){

            var category={
                "id": val.id,
                "name": val.name,
                "description": val.description
            };

            // creating new table row per record
            read_categories_html+="<tr data-category-id='" + val.id + "'>";
                read_categories_html+=getCategoryRowHtml(category);
            read_categories_html+="</tr>";

        });

        //end table
        read_categories_html+="</table>";

        // paging
        var pagination_class = keywords==""
                                ? "categories-pagination-normal"
                                : "categories-pagination-search";
        read_categories_html+=getPagination(pagination_class, response);
    }

    // inject to app
    $("#page-content").html(read_categories_html);

    // make tooltip work
    $('[data-toggle="tooltip"]').tooltip();
}

function getCategoryRowHtml(category){

    var category_row_html="";

    category_row_html+="<td class='category_td'>" + category['name'] + "</td>";
    category_row_html+="<td class='category_td'>" + category['description'] + "</td>";
    category_row_html+="<td>";

        // read category button
        category_row_html+="<button class='btn btn-primary m-r-10px read-one-category-button' data-id='" + category['id'] + "'>";
            category_row_html+="<span class='glyphicon glyphicon-eye-open'></span> Read";
        category_row_html+="</button>";

        // edit button
        category_row_html+="<button class='btn btn-info m-r-10px update-category-button' data-id='" + category['id'] + "'>";
            category_row_html+="<span class='glyphicon glyphicon-edit'></span> Edit";
        category_row_html+="</button>";

        // delete button
        category_row_html+="<button class='btn btn-danger delete-category-button' data-id='" + category['id'] + "'>";
            category_row_html+="<span class='glyphicon glyphicon-remove'></span> Delete";
        category_row_html+="</button>";
    category_row_html+="</td>";

    return category_row_html;
}
