$(document).ready(function(){

    // show html form when 'create category' button was clicked
    $(document).on('click', '.update-category-button', function(){

        // get category id
        var id = $(this).attr('data-id');

        // read one record based on given category id
        $.getJSON("http://localhost/api/category/read_one.php?id=" + id, function(data){

            var name=data.name;
            var price=data.price;
            var description=data.description;
            var category_id=data.category_id;
            var category_name=data.category_name;

        	// we have our html form here where category information will be entered
        	// we used the 'required' html5 property to prevent empty fields
            var update_category_html="";

            // when clicked, it will show the category's list
            update_category_html+="<div id='read-categories' class='btn btn-primary pull-right m-b-15px read-categories-button'>";
                update_category_html+="<span class='glyphicon glyphicon-list'></span> Read Categories";
            update_category_html+="</div>";

            update_category_html+="<form id='update-category-form' action='#' method='post' border='0'>";
                update_category_html+="<table class='table table-hover table-responsive table-bordered'>";

                    update_category_html+="<tr>";
                        update_category_html+="<td>Name</td>";
                        update_category_html+="<td><input value=\"" + name + "\" type='text' name='name' class='form-control' required /></td>";
                    update_category_html+="</tr>";

                    update_category_html+="<tr>";
                        update_category_html+="<td>Description</td>";
                        update_category_html+="<td><textarea name='description' class='form-control' required>" + description + "</textarea></td>";
                    update_category_html+="</tr>";

                    update_category_html+="<tr>";
                        update_category_html+="<td><input value=\"" + id + "\" name='id' type='hidden' /></td>";
                        update_category_html+="<td>";
                            update_category_html+="<button type='submit' class='btn btn-info'>";
            					update_category_html+="<span class='glyphicon glyphicon-edit'></span> Update Category";
            				update_category_html+="</button>";
                        update_category_html+="</td>";
                    update_category_html+="</tr>";

                update_category_html+="</table>";
            update_category_html+="</form>";

            // inject to app
            $("#page-content").html(update_category_html);

            // chage page title
            changePageTitle("Update Category");

        });
    });

    // will run if create category form was submitted
    $(document).on('submit', '#update-category-form', function(){

        // get form data
        var form_data=JSON.stringify($(this).serializeObject());

        // submit form data to api
        $.ajax({
            url: "http://localhost/api/category/update.php",
            type : "POST",
            contentType : 'application/json',
            data : form_data,
            success : function(result) {
                // category was created, go back to categories list
                showCategoriesFirstPage();
            },
            error: function(xhr, resp, text) {
                console.log(xhr, resp, text);
            }
        });

        return false;
    });

});
