$(document).ready(function(){

    // show inline editing' mode when row was clicked
    $(document).on('click', '.product_td', function(){

        // get product data
        var product_row=$(this).closest('tr');
        var product_id=product_row.attr('data-product-id');
        var product_name=$('td:eq(0)', product_row).text();
        var price=$('td:eq(1)', product_row).text();
        var category_id=$('td:eq(2)', product_row).attr('data-category-id');
        var description=$('td:eq(3) input', product_row).val();

        // remove dollar sign
        price=price.replace("$", "");

        // load list of categories
        $.getJSON("http://localhost/api/category/read.php", function(data){

            // build categories option html
            // loop through returned list of data
            var categories_options_html="";
            categories_options_html+="<select name='category_id' class='form-control'>";
            $.each(data.records, function(key, val){
                var option_selected = category_id==val.id ? "selected" : "";
                categories_options_html+="<option value='" + val.id + "' " + option_selected + ">"
                                            + val.name
                                        + "</option>";
            });
            categories_options_html+="</select>";

            var read_products_html="";
                read_products_html+="<td>";
                    read_products_html+="<input class='form-control' type='text' value='" + product_name + "' />";
                read_products_html+="</td>";

                read_products_html+="<td>";
                    read_products_html+="<input class='form-control' type='number' value='" + price + "' />";
                read_products_html+="</td>";

                read_products_html+="<td>";
                        read_products_html+=categories_options_html;
                read_products_html+="</td>";

                read_products_html+="<td>";

                    // description
                    read_products_html+="<input type='hidden' value=\"" + description + "\" />";

                    // save
                    read_products_html+="<button type='submit' class='btn btn-success m-r-10px btn_product_save_changes_inline'>";
                        read_products_html+="Save";
                    read_products_html+="</button>";

                    // cancel inline edit
                    read_products_html+="<button class='btn btn-danger m-r-10px btn_cancel_inline_product_edit'>";
                        read_products_html+="Cancel";
                    read_products_html+="</button>";
                read_products_html+="</td>";

            product_row.html(read_products_html);

        });
    });

    $(document).on('click', '.btn_product_save_changes_inline', function(){

        // get row data
        var product_row=$(this).closest('tr');
        var product = getProductData(product_row);
        var form_data=JSON.stringify(product);

        // submit form data to api
        $.ajax({
            url: "http://localhost/api/product/update.php",
            type : "POST",
            contentType : 'application/json',
            data : form_data,
            success : function(result){
                // product was updated, go back to products list
                cancelProductInlineEditing(product_row);
            },
            error: function(xhr, resp, text) {
                console.log(xhr, resp, text);
            }
        });

        return false;

    });

    $(document).on('click', '.btn_cancel_inline_product_edit', function(){
        var product_row=$(this).closest('tr');
        cancelProductInlineEditing(product_row);
    });

});

function cancelProductInlineEditing(product_row){

    var product_id=product_row.attr('data-product-id');
    var product_name=$('td:eq(0) input', product_row).val();
    var price=$('td:eq(1) input', product_row).val();
    var category_id=$('td:eq(2) select option:selected', product_row).val();
    var category_name=$('td:eq(2) select option:selected', product_row).text();
    var description=$('td:eq(3) input', product_row).val();

    var product={
        "id": product_id,
        "name": product_name,
        "price": price,
        "description": description,
        "category_id": category_id,
        "category_name": category_name
    };

    var product_row_html=getProductRowHtml(product);
    product_row.html(product_row_html);
}

function getProductData(product_row){

    var product_id=product_row.attr('data-product-id');
    var product_name=$('td:eq(0) input', product_row).val();
    var price=$('td:eq(1) input', product_row).val();
    var category_id=$('td:eq(2) select option:selected', product_row).val();
    var category_name=$('td:eq(2) select option:selected', product_row).text();
    var description=$('td:eq(3) input', product_row).val();

    var product = {
        "id": product_id,
        "name": product_name,
        "price": price,
        "description": description,
        "category_id": category_id,
        "category_name": category_name
    };

    return product;
}
